﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Media3D;

namespace ScatterChart3D
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();


            Brush brush1 = new SolidColorBrush(Color.FromArgb(85, 255, 255, 255));
            Brush brush2 = new SolidColorBrush(Color.FromArgb(55, 255, 255, 255));
            Brush brush3 = new SolidColorBrush(Color.FromArgb(50, 0, 0, 0));

            Brush stroke = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            Brush labelStroke = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));


            
            surfaceChart.Foreground = Brushes.White;
            surfaceChart.XAxisSettings.LabelFormat = "0.##";
            surfaceChart.YAxisSettings.LabelFormat = "0.##";
            surfaceChart.XAxisSettings.Stroke = stroke;
            surfaceChart.XAxisSettings.LabelStroke = labelStroke;
            surfaceChart.YAxisSettings.Stroke = stroke;
            surfaceChart.YAxisSettings.LabelStroke = labelStroke;
            surfaceChart.GridFills = new List<Brush>();
            surfaceChart.GridStrokes = new List<Brush>();
            surfaceChart.GridFills.Add(brush1);
            surfaceChart.GridFills.Add(brush2);
            surfaceChart.GridStrokes.Add(brush3);

            surfaceChart.ZAxisSettings.LabelType = LabelType.Empty;
            surfaceChart.XAxisSettings.Title = "";
            surfaceChart.YAxisSettings.Title = "";

            surfaceChart.XAxisSettings.MinValue = 0;
            surfaceChart.XAxisSettings.MaxValue = 30;
            surfaceChart.YAxisSettings.MinValue = 0;
            surfaceChart.YAxisSettings.MaxValue = 20;
            surfaceChart.ZAxisSettings.MinValue = 0;
            surfaceChart.ZAxisSettings.MaxValue = 30;

            Random r = new Random();
            for (int i = 0; i < 100; i++)
            {
                series1.XData.Add(r.Next(24) + 3);
                series1.YData.Add(r.Next(18) + 1);
                series1.ZData.Add(r.Next(24) + 3);
                series1.ScatterSize.Add(r.NextDouble()* 2 + 0.5);
            }
        }

        private void surfaceChart_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Point3D? clickPoint = surfaceChart.HitTest(e.GetPosition(surfaceChart)).ClosestPeak;
            if (clickPoint != null)
            {
                string s = "";
                s += "Scatter(" + clickPoint.Value.X.ToString() + "," + clickPoint.Value.Y.ToString() +
                    "," + clickPoint.Value.Z.ToString() + ")  ";
                MessageBox.Show(s);
            }
        }
    }
}
